<template>
  <div class="pt">
    <!-- table.pt-users>(thead.-thead>tr.-tr>th.-th*5{test})+(tbody.-tbody>tr.-tr>td.-td) -->
    <table class="pt-users">
      <thead class="pt-users__thead">
        <tr class="pt-users__tr">
          <th class="pt-users__th">№</th>
          <th class="pt-users__th">Автор</th>
          <th class="pt-users__th">Имя автора</th>
          <th class="pt-users__th">Компания</th>
          <th class="pt-users__th">Сайт</th>
          <th class="pt-users__th"></th>
        </tr>
      </thead>
      <tbody class="pt-users__tbody">
        <template v-for="user in responseData" :key="user.id">
          <tr class="pt-users__tr">
            <td class="pt-users__td">{{ user.id }}</td>
            <td class="pt-users__td">{{ user.username }}</td>
            <td class="pt-users__td">{{ user.name }}</td>
            <td class="pt-users__td">{{ user.company.name }}</td>
            <td class="pt-users__td">{{ user.website }}</td>
            <td class="pt-users__td">
              <btn-toggle @click="toggleTablePosts(user.id)"></btn-toggle>
            </td>
          </tr>
          <tr class="pt-users__tr pt-users__tr_posts" ref="tablePosts">
            <td colspan="6">
              <PostsTablePosts
                :user="user.id"
                @edit-post="toggleModal($event)"
              />
            </td>
          </tr>
        </template>
      </tbody>
    </table>
    <teleport to="body">
      <PostsFormEdit
        v-show="postId"
        id="modal"
        :post-id="postId"
        :post-title="postTitle"
        :post-text="postText"
      >
        <button @click="postId = NaN" class="modal__close">Закрыть</button>
      </PostsFormEdit>
    </teleport>
  </div>
</template>

<script setup>
import { ref, defineCustomElement } from "vue";
import PostsTablePosts from "@/components/posts-table/PostsTablePosts.vue";
import PostsFormEdit from "@/components/posts-table/PostsFormEdit.vue";
import BtnToggle from "@/components/ui/BtnToggle.ce.vue";

// получение данных о пользователях для таблицы
const responseUrl = "https://jsonplaceholder.typicode.com/users";
let responseData = ref([]);

(async () => {
  const response = await fetch(responseUrl);
  responseData.value = await response.json();
})();

// кнопка показать посты
let tablePosts = ref([]);
customElements.define("btn-toggle", defineCustomElement(BtnToggle));

const toggleTablePosts = (id) => {
  const tablePost = tablePosts.value[id - 1];
  if (getComputedStyle(tablePost).display == "none") {
    tablePost.classList.add("jsShowTablePosts");
  } else {
    tablePost.classList.remove("jsShowTablePosts");
  }
};

let postId = ref(),
  postTitle = ref(),
  postText = ref();
const toggleModal = (param) => {
  postId.value = param.postID;
  postTitle.value = param.postName;
  postText.value = param.postBody;
};
</script>

<style lang="less">
.pt-users {
  min-width: 1000px;
  text-align: center;
}
.pt-users__tr {
  &_posts {
    display: none;
  }
}
.pt-users__td {
  padding: 5px;
}

.jsShowTablePosts {
  display: table-row;
}
</style>
